var search_data = {"index":{"searchIndex":["array","deepenumerable","hash","deep_diff()","deep_diff_symmetric()","deep_dup()","deep_each()","deep_flat_map()","deep_get()","deep_inject()","deep_intersect()","deep_key_from_array()","deep_key_to_array()","deep_map()","deep_map!()","deep_map_values()","deep_map_values!()","deep_outersect()","deep_reject()","deep_select()","deep_set()","deep_values()","deep_zip()","depth_first_map()","empty()","leaf_key()","nested_key?()","shallow_each()","shallow_key_value_pairs()","shallow_keys()","shallow_map_keys()","shallow_map_keys!()","shallow_map_values()","shallow_map_values!()","split_key()"],"longSearchIndex":["array","deepenumerable","hash","deepenumerable#deep_diff()","deepenumerable#deep_diff_symmetric()","deepenumerable#deep_dup()","deepenumerable#deep_each()","deepenumerable#deep_flat_map()","deepenumerable#deep_get()","deepenumerable#deep_inject()","deepenumerable#deep_intersect()","deepenumerable::deep_key_from_array()","deepenumerable::deep_key_to_array()","deepenumerable#deep_map()","deepenumerable#deep_map!()","deepenumerable#deep_map_values()","deepenumerable#deep_map_values!()","deepenumerable#deep_outersect()","deepenumerable#deep_reject()","deepenumerable#deep_select()","deepenumerable#deep_set()","deepenumerable#deep_values()","deepenumerable#deep_zip()","deepenumerable#depth_first_map()","deepenumerable#empty()","deepenumerable::leaf_key()","deepenumerable::nested_key?()","deepenumerable#shallow_each()","deepenumerable#shallow_key_value_pairs()","array#shallow_keys()","deepenumerable#shallow_map_keys()","deepenumerable#shallow_map_keys!()","deepenumerable#shallow_map_values()","deepenumerable#shallow_map_values!()","deepenumerable::split_key()"],"info":[["Array","","Array.html","","<p>This class implements the necessary methods to qualify Array as a DeepEnumerable\n"],["DeepEnumerable","","DeepEnumerable.html","","<p>A set of general methods that can be applied to any conformant nested structure\n"],["Hash","","Hash.html","","<p>This class implements the necessary methods to qualify Hash as a DeepEnumerable\n"],["deep_diff","DeepEnumerable","DeepEnumerable.html#method-i-deep_diff","(other, &block)","<p>Subtracts the leaves of one DeepEnumerable from another.\n<p>@return a result of the same structure as the …\n"],["deep_diff_symmetric","DeepEnumerable","DeepEnumerable.html#method-i-deep_diff_symmetric","(other, &block)","<p>Computes the complement of the intersection of two DeepEnumerables.\n<p>@return The common structure of both …\n"],["deep_dup","DeepEnumerable","DeepEnumerable.html#method-i-deep_dup","()","<p>Deeply copy a DeepEnumerable\n<p>@return the same data structure at a different memory address\n"],["deep_each","DeepEnumerable","DeepEnumerable.html#method-i-deep_each","(&block)","<p>Iterate elements of a DeepEnumerable\n<p>@example\n\n<pre>&gt;&gt; {event: {id: 1, title: &#39;bowling&#39;}}.deep_each.to_a\n=&gt; [[{:event=&gt;:id}, ...</pre>\n"],["deep_flat_map","DeepEnumerable","DeepEnumerable.html#method-i-deep_flat_map","(&block)","<p>Concatenate all the results from the supplied code block together.\n<p>@return an array with the results of …\n"],["deep_get","DeepEnumerable","DeepEnumerable.html#method-i-deep_get","(key)","<p>Retrieve a nested element from a DeepEnumerable\n<p>@example\n\n<pre>&gt;&gt; prefix_tree = {&quot;a&quot;=&gt;{&quot;a&quot;=&gt;&quot;aardvark&quot;, &quot;b&quot;=&gt;[&quot;abacus&quot;, ...</pre>\n"],["deep_inject","DeepEnumerable","DeepEnumerable.html#method-i-deep_inject","(initial, &block)","<p>Fold over all leaf nodes\n<p>@example\n\n<pre>&gt;&gt; friends = [{name: &#39;alice&#39;, age: 26}, {name: &#39;bob&#39;, age: 26}]\n&gt;&gt; friends.deep_inject(Hash.new{[]}) ...</pre>\n"],["deep_intersect","DeepEnumerable","DeepEnumerable.html#method-i-deep_intersect","(other, &block)","<p>Describes the similarities between two DeepEnumerables.\n<p>@example\n\n<pre>&gt;&gt; alice = {:name=&gt;&quot;alice&quot;, :age=&gt;26} ...</pre>\n"],["deep_key_from_array","DeepEnumerable","DeepEnumerable.html#method-c-deep_key_from_array","(array)","<p>Everything below should be a class method, but Ruby method visibility is a nightmare\n"],["deep_key_to_array","DeepEnumerable","DeepEnumerable.html#method-c-deep_key_to_array","(key)","<p>DeepEnumerable keys are represented as hashes, this function converts them to arrays for convenience …\n"],["deep_map","DeepEnumerable","DeepEnumerable.html#method-i-deep_map","(&block)","<p>Create a new nested structure populated by the result of executing <code>block</code> on the deep-keys and values …\n"],["deep_map!","DeepEnumerable","DeepEnumerable.html#method-i-deep_map-21","(&block)","<p>Returns the result of running block on each leaf of this DeepEnumerable\n<p>@example\n\n<pre>&gt;&gt; h = {a: [1, 2]}\n&gt;&gt; ...</pre>\n"],["deep_map_values","DeepEnumerable","DeepEnumerable.html#method-i-deep_map_values","(&block)","<p>Creates a new nested structure populated by the result of executing <code>block</code> on the values of the original …\n"],["deep_map_values!","DeepEnumerable","DeepEnumerable.html#method-i-deep_map_values-21","(&block)","<p>Modifies this collection to use the result of <code>block</code> as the values\n<p>@example\n\n<pre>&gt;&gt; h = {a: [1, 2]}\n&gt;&gt; h.deep_map_values!{v| ...</pre>\n"],["deep_outersect","DeepEnumerable","DeepEnumerable.html#method-i-deep_outersect","(other, &block)",""],["deep_reject","DeepEnumerable","DeepEnumerable.html#method-i-deep_reject","(&block)","<p>Filter leaf nodes by the result of the given block\n<p>@example\n\n<pre>&gt;&gt; inventory = {fruit: {apples: 4, oranges: ...</pre>\n"],["deep_select","DeepEnumerable","DeepEnumerable.html#method-i-deep_select","(&block)","<p>Filter leaf nodes by the result of the given block\n<p>@example\n\n<pre>&gt;&gt; inventory = {fruit: {apples: 4, oranges: ...</pre>\n"],["deep_set","DeepEnumerable","DeepEnumerable.html#method-i-deep_set","(key, val)","<p>Update a DeepEnumerable, indexed by an Array or Hash.\n<p>Intermediate values are created when necessary, …\n"],["deep_values","DeepEnumerable","DeepEnumerable.html#method-i-deep_values","()","<p>List the values stored at every leaf\n<p>@example\n\n<pre>&gt;&gt; prefix_tree = {&quot;a&quot;=&gt;{&quot;a&quot;=&gt;&quot;aardvark&quot;, &quot;b&quot;=&gt;[&quot;abacus&quot;, ...</pre>\n"],["deep_zip","DeepEnumerable","DeepEnumerable.html#method-i-deep_zip","(other)","<p>Combine two DeepEnumerables into one, with the elements from each joined into tuples\n<p>@example\n\n<pre>&gt;&gt; inventory ...</pre>\n"],["depth_first_map","DeepEnumerable","DeepEnumerable.html#method-i-depth_first_map","(ancestry=[])","<p>def shallow_get(x) # this should technically be defined in Hash/Array individually\n\n<pre class=\"ruby\"><span class=\"ruby-keyword\">self</span>[<span class=\"ruby-identifier\">x</span>]\n</pre>\n<p>end\n"],["empty","DeepEnumerable","DeepEnumerable.html#method-i-empty","()","<p>A copy of the DeepEnumerable containing no elements\n<p>@example\n\n<pre>&gt;&gt; inventory = {fruit: {apples: 4, oranges: ...</pre>\n"],["leaf_key","DeepEnumerable","DeepEnumerable.html#method-c-leaf_key","(key)","<p>Get the lowest-level key\n<p>for example: {a: {b: :c}} goes to :c\n"],["nested_key?","DeepEnumerable","DeepEnumerable.html#method-c-nested_key-3F","(key)",""],["shallow_each","DeepEnumerable","DeepEnumerable.html#method-i-shallow_each","(&block)","<p>The primary iterator of a DeepEnumerable If this method is implemented DeepEnumerable can construct every …\n"],["shallow_key_value_pairs","DeepEnumerable","DeepEnumerable.html#method-i-shallow_key_value_pairs","()","\n<pre>Provide a homogenous |k,v| iterator for Arrays/Hashes/DeepEnumerables</pre>\n<p>TODO test this\n"],["shallow_keys","Array","Array.html#method-i-shallow_keys","()",""],["shallow_map_keys","DeepEnumerable","DeepEnumerable.html#method-i-shallow_map_keys","(&block)","<p>Returns a new collection where every top-level element is replaced with the result of the given block …\n"],["shallow_map_keys!","DeepEnumerable","DeepEnumerable.html#method-i-shallow_map_keys-21","(&block)","<p>Replaces every top-level element with the result of the given block\n"],["shallow_map_values","DeepEnumerable","DeepEnumerable.html#method-i-shallow_map_values","(&block)","<p>Returns a new collection where every top-level element is replaced with the result of the given block …\n"],["shallow_map_values!","DeepEnumerable","DeepEnumerable.html#method-i-shallow_map_values-21","(&block)","<p>Replaces every top-level element with the result of the given block\n"],["split_key","DeepEnumerable","DeepEnumerable.html#method-c-split_key","(key)","<p>Disassembles a key into its head and tail elements\n<p>@example\n\n<pre>&gt;&gt; DeepEnumerable.split_key({a: {0 =&gt; :a}}) ...</pre>\n"]]}}